<?php

/**
 * Plugin Name: DALL-E Featured Image Generator
 * Description: Automatically generates and assigns featured images to posts using the OpenAI DALL-E API.
 * Version: 1.0
 * Author: Nelito
 * Author URI: https://nltw.xyz
 */

require_once plugin_dir_path(__FILE__) . 'dallegenerator.php';
require_once plugin_dir_path(__FILE__) . 'admin.php';

add_action('save_post', 'dalle_generate_featured_image');

function dalle_generate_featured_image($post_id)
{
    if (has_post_thumbnail($post_id)) {
        return;
    }

    if (get_post_type($post_id) !== 'post' || wp_is_post_revision($post_id)) {
        return;
    }

    $post_title = get_the_title($post_id);

    $image_path = generate_dalle_image($post_title, sanitize_title($post_title));
    if ($image_path) {
        $attachment_id = dalle_insert_attachment($image_path, $post_id);

        if ($attachment_id) {
            set_post_thumbnail($post_id, $attachment_id);
        }
    }
}

